Index: src/language/data-io/matrix-data.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/data-io/matrix-data.c,v
retrieving revision 1.16
diff -b -w -U3 -r1.16 matrix-data.c
--- src/language/data-io/matrix-data.c	3 Nov 2006 04:53:51 -0000	1.16
+++ src/language/data-io/matrix-data.c	11 Nov 2006 00:13:14 -0000
@@ -170,11 +170,11 @@
 					     const void *pb);
 static bool read_matrices_without_rowtype (struct dataset *ds, struct matrix_data_pgm *);
 static bool read_matrices_with_rowtype (struct dataset *ds, struct matrix_data_pgm *);
-static int string_to_content_type (char *, int *);
+static int string_to_content_type (const char *, int *);
 static void attach_mxd_aux (struct variable *, int var_type, int sub_type);
 
 int
-cmd_matrix_data (struct dataset *ds)
+cmd_matrix_data (struct lexer *lexer, struct dataset *ds)
 {
   struct pool *pool;
   struct matrix_data_pgm *mx;
@@ -204,11 +204,11 @@
   mx->n_contents = 0;
   mx->n_continuous = 0;
   mx->first_continuous = 0;
-  while (token != '.')
+  while (lex_token (lexer) != '.')
     {
-      lex_match ('/');
+      lex_match (lexer, '/');
 
-      if (lex_match_id ("VARIABLES"))
+      if (lex_match_id (lexer, "VARIABLES"))
 	{
 	  char **v;
 	  size_t nv;
@@ -220,8 +220,8 @@
 	    }
 	  seen |= 1;
 	  
-	  lex_match ('=');
-	  if (!parse_DATA_LIST_vars (&v, &nv, PV_NO_DUPLICATE))
+	  lex_match (lexer, '=');
+	  if (!parse_DATA_LIST_vars (lexer, &v, &nv, PV_NO_DUPLICATE))
 	    goto lossage;
 	  
 	  {
@@ -262,43 +262,43 @@
                                                  "ROWTYPE_", 8);
           attach_mxd_aux (mx->rowtype_, MXD_ROWTYPE, 0);
 	}
-      else if (lex_match_id ("FILE"))
+      else if (lex_match_id (lexer, "FILE"))
 	{
-	  lex_match ('=');
-	  fh = fh_parse (FH_REF_FILE | FH_REF_INLINE);
+	  lex_match (lexer, '=');
+	  fh = fh_parse (lexer, FH_REF_FILE | FH_REF_INLINE);
 	  if (fh == NULL)
 	    goto lossage;
 	}
-      else if (lex_match_id ("FORMAT"))
+      else if (lex_match_id (lexer, "FORMAT"))
 	{
-	  lex_match ('=');
+	  lex_match (lexer, '=');
 
-	  while (token == T_ID)
+	  while (lex_token (lexer) == T_ID)
 	    {
-	      if (lex_match_id ("LIST"))
+	      if (lex_match_id (lexer, "LIST"))
 		mx->fmt = LIST;
-	      else if (lex_match_id ("FREE"))
+	      else if (lex_match_id (lexer, "FREE"))
 		mx->fmt = FREE;
-	      else if (lex_match_id ("LOWER"))
+	      else if (lex_match_id (lexer, "LOWER"))
 		mx->section = LOWER;
-	      else if (lex_match_id ("UPPER"))
+	      else if (lex_match_id (lexer, "UPPER"))
 		mx->section = UPPER;
-	      else if (lex_match_id ("FULL"))
+	      else if (lex_match_id (lexer, "FULL"))
 		mx->section = FULL;
-	      else if (lex_match_id ("DIAGONAL"))
+	      else if (lex_match_id (lexer, "DIAGONAL"))
 		mx->diag = DIAGONAL;
-	      else if (lex_match_id ("NODIAGONAL"))
+	      else if (lex_match_id (lexer, "NODIAGONAL"))
 		mx->diag = NODIAGONAL;
 	      else 
 		{
-		  lex_error (_("in FORMAT subcommand"));
+		  lex_error (lexer, _("in FORMAT subcommand"));
 		  goto lossage;
 		}
 	    }
 	}
-      else if (lex_match_id ("SPLIT"))
+      else if (lex_match_id (lexer, "SPLIT"))
 	{
-	  lex_match ('=');
+	  lex_match (lexer, '=');
 
 	  if (seen & 2)
 	    {
@@ -307,17 +307,17 @@
 	    }
 	  seen |= 2;
 	  
-	  if (token != T_ID)
+	  if (lex_token (lexer) != T_ID)
 	    {
-	      lex_error (_("in SPLIT subcommand"));
+	      lex_error (lexer, _("in SPLIT subcommand"));
 	      goto lossage;
 	    }
 	  
-	  if (dict_lookup_var (dataset_dict (ds), tokid) == NULL
-	      && (lex_look_ahead () == '.' || lex_look_ahead () == '/'))
+	  if (dict_lookup_var (dataset_dict (ds), lex_tokid (lexer)) == NULL
+	      && (lex_look_ahead (lexer) == '.' || lex_look_ahead (lexer) == '/'))
 	    {
-	      if (!strcasecmp (tokid, "ROWTYPE_")
-                  || !strcasecmp (tokid, "VARNAME_"))
+	      if (!strcasecmp (lex_tokid (lexer), "ROWTYPE_")
+                  || !strcasecmp (lex_tokid (lexer), "VARNAME_"))
 		{
 		  msg (SE, _("Split variable may not be named ROWTYPE_ "
 			     "or VARNAME_."));
@@ -325,9 +325,9 @@
 		}
 
 	      mx->single_split = dict_create_var_assert (dataset_dict (ds),
-                                                         tokid, 0);
+                                                         lex_tokid (lexer), 0);
               attach_mxd_aux (mx->single_split, MXD_CONTINUOUS, 0);
-	      lex_get ();
+	      lex_get (lexer);
 
               dict_set_split_vars (dataset_dict (ds), &mx->single_split, 1);
 	    }
@@ -336,7 +336,8 @@
 	      struct variable **split;
 	      size_t n;
 
-	      if (!parse_variables (dataset_dict (ds), &split, &n, PV_NO_DUPLICATE))
+	      if (!parse_variables (lexer, dataset_dict (ds), 
+				    &split, &n, PV_NO_DUPLICATE))
 		goto lossage;
 
               dict_set_split_vars (dataset_dict (ds), split, n);
@@ -354,7 +355,7 @@
 		if (mv->var_type != MXD_CONTINUOUS)
 		  {
 		    msg (SE, _("Split variable %s is already another type."),
-			 tokid);
+			 lex_tokid (lexer));
 		    goto lossage;
 		  }
                 var_clear_aux (split[i]);
@@ -362,9 +363,9 @@
               }
 	  }
 	}
-      else if (lex_match_id ("FACTORS"))
+      else if (lex_match_id (lexer, "FACTORS"))
 	{
-	  lex_match ('=');
+	  lex_match (lexer, '=');
 	  
 	  if (seen & 4)
 	    {
@@ -373,7 +374,7 @@
 	    }
 	  seen |= 4;
 
-	  if (!parse_variables (dataset_dict (ds), &mx->factors, &mx->n_factors,
+	  if (!parse_variables (lexer, dataset_dict (ds), &mx->factors, &mx->n_factors,
                                 PV_NONE))
 	    goto lossage;
 	  
@@ -388,7 +389,7 @@
 		if (mv->var_type != MXD_CONTINUOUS)
 		  {
 		    msg (SE, _("Factor variable %s is already another type."),
-			 tokid);
+			 lex_tokid (lexer));
 		    goto lossage;
 		  }
                 var_clear_aux (v);
@@ -396,9 +397,9 @@
 	      }
 	  }
 	}
-      else if (lex_match_id ("CELLS"))
+      else if (lex_match_id (lexer, "CELLS"))
 	{
-	  lex_match ('=');
+	  lex_match (lexer, '=');
 	  
 	  if (mx->cells != -1)
 	    {
@@ -406,18 +407,18 @@
 	      goto lossage;
 	    }
 
-	  if (!lex_is_integer () || lex_integer () < 1)
+	  if (!lex_is_integer (lexer) || lex_integer (lexer) < 1)
 	    {
-	      lex_error (_("expecting positive integer"));
+	      lex_error (lexer, _("expecting positive integer"));
 	      goto lossage;
 	    }
 
-	  mx->cells = lex_integer ();
-	  lex_get ();
+	  mx->cells = lex_integer (lexer);
+	  lex_get (lexer);
 	}
-      else if (lex_match_id ("N"))
+      else if (lex_match_id (lexer, "N"))
 	{
-	  lex_match ('=');
+	  lex_match (lexer, '=');
 
 	  if (mx->pop_n != -1)
 	    {
@@ -425,16 +426,16 @@
 	      goto lossage;
 	    }
 
-	  if (!lex_is_integer () || lex_integer () < 1)
+	  if (!lex_is_integer (lexer) || lex_integer (lexer) < 1)
 	    {
-	      lex_error (_("expecting positive integer"));
+	      lex_error (lexer, _("expecting positive integer"));
 	      goto lossage;
 	    }
 
-	  mx->pop_n = lex_integer ();
-	  lex_get ();
+	  mx->pop_n = lex_integer (lexer);
+	  lex_get (lexer);
 	}
-      else if (lex_match_id ("CONTENTS"))
+      else if (lex_match_id (lexer, "CONTENTS"))
 	{
 	  int inside_parens = 0;
 	  unsigned collide = 0;
@@ -447,7 +448,7 @@
 	    }
 	  seen |= 8;
 
-	  lex_match ('=');
+	  lex_match (lexer, '=');
 	  
 	  {
 	    int i;
@@ -458,7 +459,7 @@
 
 	  for (;;)
 	    {
-	      if (lex_match ('('))
+	      if (lex_match (lexer, '('))
 		{
 		  if (inside_parens)
 		    {
@@ -468,7 +469,7 @@
 		  inside_parens = 1;
 		  item = LPAREN;
 		}
-	      else if (lex_match (')'))
+	      else if (lex_match (lexer, ')'))
 		{
 		  if (!inside_parens)
 		    {
@@ -488,20 +489,20 @@
 		  int content_type;
 		  int collide_index;
 		  
-		  if (token != T_ID)
+		  if (lex_token (lexer) != T_ID)
 		    {
-		      lex_error (_("in CONTENTS subcommand"));
+		      lex_error (lexer, _("in CONTENTS subcommand"));
 		      goto lossage;
 		    }
 
-		  content_type = string_to_content_type (tokid,
+		  content_type = string_to_content_type (lex_tokid (lexer),
 							 &collide_index);
 		  if (content_type == -1)
 		    {
-		      lex_error (_("in CONTENTS subcommand"));
+		      lex_error (lexer, _("in CONTENTS subcommand"));
 		      goto lossage;
 		    }
-		  lex_get ();
+		  lex_get (lexer);
 
 		  if (collide & (1 << collide_index))
 		    {
@@ -516,7 +517,7 @@
 		}
 	      mx->contents[mx->n_contents++] = item;
 
-	      if (token == '/' || token == '.')
+	      if (lex_token (lexer) == '/' || lex_token (lexer) == '.')
 		break;
 	    }
 
@@ -529,14 +530,14 @@
 	}
       else 
 	{
-	  lex_error (NULL);
+	  lex_error (lexer, NULL);
 	  goto lossage;
 	}
     }
   
-  if (token != '.')
+  if (lex_token (lexer) != '.')
     {
-      lex_error (_("expecting end of command"));
+      lex_error (lexer, _("expecting end of command"));
       goto lossage;
     }
   
@@ -623,7 +624,7 @@
       goto lossage;
     }
 
-  mx->reader = dfm_open_reader (fh);
+  mx->reader = dfm_open_reader (fh, lexer);
   if (mx->reader == NULL)
     goto lossage;
 
@@ -651,7 +652,7 @@
    as a bit-index) which can be used for determining whether a related
    statistic has already been used. */
 static int
-string_to_content_type (char *s, int *collide)
+string_to_content_type (const char *s, int *collide)
 {
   static const struct
     {
Index: src/language/data-io/placement-parser.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/data-io/placement-parser.c,v
retrieving revision 1.2
diff -b -w -U3 -r1.2 placement-parser.c
--- src/language/data-io/placement-parser.c	3 Nov 2006 04:53:51 -0000	1.2
+++ src/language/data-io/placement-parser.c	11 Nov 2006 00:13:14 -0000
@@ -44,9 +44,9 @@
     PRS_TYPE_NEW_REC            /* Next record. */
   };
 
-static bool fixed_parse_columns (struct pool *, size_t var_cnt, bool for_input,
+static bool fixed_parse_columns (struct lexer *, struct pool *, size_t var_cnt, bool for_input,
                                  struct fmt_spec **, size_t *);
-static bool fixed_parse_fortran (struct pool *, bool for_input,
+static bool fixed_parse_fortran (struct lexer *l, struct pool *, bool for_input,
                                  struct fmt_spec **, size_t *);
 
 /* Parses Fortran-like or column-based specifications for placing
@@ -65,18 +65,18 @@
    Uses POOL for allocation.  When the caller is finished
    interpreting *FORMATS, POOL may be destroyed. */
 bool
-parse_var_placements (struct pool *pool, size_t var_cnt, bool for_input,
+parse_var_placements (struct lexer *lexer, struct pool *pool, size_t var_cnt, bool for_input,
                       struct fmt_spec **formats, size_t *format_cnt) 
 {
   assert (var_cnt > 0);
-  if (lex_is_number ())
-    return fixed_parse_columns (pool, var_cnt, for_input, formats, format_cnt);
-  else if (lex_match ('(')) 
+  if (lex_is_number (lexer))
+    return fixed_parse_columns (lexer, pool, var_cnt, for_input, formats, format_cnt);
+  else if (lex_match (lexer, '(')) 
     {
       size_t assignment_cnt;
       size_t i;
 
-      if (!fixed_parse_fortran (pool, for_input, formats, format_cnt))
+      if (!fixed_parse_fortran (lexer, pool, for_input, formats, format_cnt))
         return false; 
 
       assignment_cnt = 0;
@@ -103,14 +103,14 @@
 
 /* Implements parse_var_placements for column-based formats. */
 static bool
-fixed_parse_columns (struct pool *pool, size_t var_cnt, bool for_input,
+fixed_parse_columns (struct lexer *lexer, struct pool *pool, size_t var_cnt, bool for_input,
                      struct fmt_spec **formats, size_t *format_cnt)
 {
   struct fmt_spec format;
   int fc, lc;
   size_t i;
 
-  if (!parse_column_range (&fc, &lc, NULL))
+  if ( !parse_column_range (lexer, &fc, &lc, NULL) )
     return false;
 
   /* Divide columns evenly. */    
@@ -124,28 +124,28 @@
     }
 
   /* Format specifier. */
-  if (lex_match ('('))
+  if (lex_match (lexer, '('))
     {
       /* Get format type. */
-      if (token == T_ID)
+      if (lex_token (lexer) == T_ID)
 	{
-	  if (!parse_format_specifier_name (&format.type))
+	  if (!parse_format_specifier_name (lexer, &format.type))
             return false;
-	  lex_match (',');
+	  lex_match (lexer, ',');
 	}
       else
 	format.type = FMT_F;
 
       /* Get decimal places. */
-      if (lex_is_integer ())
+      if (lex_is_integer (lexer))
 	{
-	  format.d = lex_integer ();
-	  lex_get ();
+	  format.d = lex_integer (lexer);
+	  lex_get (lexer);
 	}
       else
 	format.d = 0;
 
-      if (!lex_force_match (')'))
+      if (!lex_force_match (lexer, ')'))
 	return false;
     }
   else
@@ -167,14 +167,14 @@
 
 /* Implements parse_var_placements for Fortran-like formats. */
 static bool
-fixed_parse_fortran (struct pool *pool, bool for_input,
+fixed_parse_fortran (struct lexer *lexer, struct pool *pool, bool for_input,
                      struct fmt_spec **formats, size_t *format_cnt)
 {
   size_t formats_allocated = 0;
   size_t formats_used = 0;
 
   *formats = NULL;
-  while (!lex_match (')'))
+  while (!lex_match (lexer, ')'))
     {
       struct fmt_spec f;
       struct fmt_spec *new_formats;
@@ -183,19 +183,19 @@
       size_t formats_needed;
       
       /* Parse count. */
-      if (lex_is_integer ())
+      if (lex_is_integer (lexer))
 	{
-	  count = lex_integer ();
-	  lex_get ();
+	  count = lex_integer (lexer);
+	  lex_get (lexer);
 	}
       else
 	count = 1;
 
       /* Parse format specifier. */
-      if (lex_match ('('))
+      if (lex_match (lexer, '('))
         {
           /* Call ourselves recursively to handle parentheses. */
-          if (!fixed_parse_fortran (pool, for_input,
+          if (!fixed_parse_fortran (lexer, pool, for_input,
                                     &new_formats, &new_format_cnt))
             return false;
         }
@@ -203,13 +203,13 @@
         {
           new_formats = &f;
           new_format_cnt = 1;
-          if (lex_match ('/'))
+          if (lex_match (lexer, '/'))
             f.type = PRS_TYPE_NEW_REC;
           else
             {
               char type[FMT_TYPE_LEN_MAX + 1];
               
-              if (!parse_abstract_format_specifier (type, &f.w, &f.d))
+              if (!parse_abstract_format_specifier (lexer, type, &f.w, &f.d))
                 return false;
 
               if (!strcasecmp (type, "T")) 
@@ -254,7 +254,7 @@
           formats_used += new_format_cnt;
         }
 
-      lex_match (',');
+      lex_match (lexer, ',');
     }
 
   *format_cnt = formats_used;
@@ -299,27 +299,27 @@
    successful, false if the syntax was invalid or the values
    specified did not make sense. */
 bool
-parse_column_range (int *first_column, int *last_column,
+parse_column_range (struct lexer *lexer, int *first_column, int *last_column,
                     bool *range_specified) 
 {
   /* First column. */
-  if (!lex_force_int ())
+  if (!lex_force_int (lexer))
     return false;
-  *first_column = lex_integer ();
+  *first_column = lex_integer (lexer);
   if (*first_column < 1)
     {
       msg (SE, _("Column positions for fields must be positive."));
       return false;
     }
-  lex_get ();
+  lex_get (lexer);
 
   /* Last column. */
-  lex_negative_to_dash ();
-  if (lex_match ('-'))
+  lex_negative_to_dash (lexer);
+  if (lex_match (lexer, '-'))
     {
-      if (!lex_force_int ())
+      if (!lex_force_int (lexer))
 	return false;
-      *last_column = lex_integer ();
+      *last_column = lex_integer (lexer);
       if (*last_column < 1)
 	{
 	  msg (SE, _("Column positions for fields must be positive."));
@@ -334,7 +334,7 @@
 
       if (range_specified)
         *range_specified = true;
-      lex_get ();
+      lex_get (lexer);
     }
   else 
     {
@@ -354,23 +354,23 @@
 
    Returns true if successful, false on syntax error. */
 bool
-parse_record_placement (int *record, int *column) 
+parse_record_placement (struct lexer *lexer, int *record, int *column) 
 {
-  while (lex_match ('/'))
+  while (lex_match (lexer, '/'))
     {
-      if (lex_is_integer ())
+      if (lex_is_integer (lexer))
         {
-          if (lex_integer () <= *record)
+          if (lex_integer (lexer) <= *record)
             {
               msg (SE, _("The record number specified, %ld, is at or "
                          "before the previous record, %d.  Data "
                          "fields must be listed in order of "
                          "increasing record number."),
-                   lex_integer (), *record);
+                   lex_integer (lexer), *record);
               return false;
             }
-          *record = lex_integer ();
-          lex_get ();
+          *record = lex_integer (lexer);
+          lex_get (lexer);
         }
       else
         (*record)++;
Index: src/language/data-io/placement-parser.h
===================================================================
RCS file: /sources/pspp/pspp/src/language/data-io/placement-parser.h,v
retrieving revision 1.2
diff -b -w -U3 -r1.2 placement-parser.h
--- src/language/data-io/placement-parser.h	3 Nov 2006 04:53:51 -0000	1.2
+++ src/language/data-io/placement-parser.h	11 Nov 2006 00:13:14 -0000
@@ -25,13 +25,14 @@
 
 struct fmt_spec;
 struct pool;
+struct lexer;
 
-bool parse_record_placement (int *record, int *column);
-bool parse_var_placements (struct pool *, size_t var_cnt, bool for_input,
+bool parse_record_placement (struct lexer *, int *record, int *column);
+bool parse_var_placements (struct lexer *, struct pool *, size_t var_cnt, bool for_input,
                            struct fmt_spec **, size_t *format_cnt);
 bool execute_placement_format (const struct fmt_spec *,
                                int *record, int *column);
-bool parse_column_range (int *first_column, int *last_column,
+bool parse_column_range (struct lexer *, int *first_column, int *last_column,
                          bool *range_specified);
 
 #endif /* language/data-io/placement-parser.h */
Index: src/language/data-io/print-space.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/data-io/print-space.c,v
retrieving revision 1.6
diff -b -w -U3 -r1.6 print-space.c
--- src/language/data-io/print-space.c	1 Nov 2006 02:22:35 -0000	1.6
+++ src/language/data-io/print-space.c	11 Nov 2006 00:13:14 -0000
@@ -47,32 +47,32 @@
 static trns_free_func print_space_trns_free;
 
 int
-cmd_print_space (struct dataset *ds)
+cmd_print_space (struct lexer *lexer, struct dataset *ds)
 {
   struct print_space_trns *trns;
   struct file_handle *handle;
   struct expression *expr;
   struct dfm_writer *writer;
 
-  if (lex_match_id ("OUTFILE"))
+  if (lex_match_id (lexer, "OUTFILE"))
     {
-      lex_match ('=');
+      lex_match (lexer, '=');
 
-      handle = fh_parse (FH_REF_FILE);
+      handle = fh_parse (lexer, FH_REF_FILE);
       if (handle == NULL)
 	return CMD_FAILURE;
-      lex_get ();
+      lex_get (lexer);
     }
   else
     handle = NULL;
 
-  if (token != '.')
+  if (lex_token (lexer) != '.')
     {
-      expr = expr_parse (ds, EXPR_NUMBER);
-      if (token != '.')
+      expr = expr_parse (lexer, ds, EXPR_NUMBER);
+      if (lex_token (lexer) != '.')
 	{
 	  expr_free (expr);
-	  lex_error (_("expecting end of command"));
+	  lex_error (lexer, _("expecting end of command"));
 	  return CMD_FAILURE;
 	}
     }
Index: src/language/data-io/print.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/data-io/print.c,v
retrieving revision 1.19
diff -b -w -U3 -r1.19 print.c
--- src/language/data-io/print.c	5 Nov 2006 05:20:53 -0000	1.19
+++ src/language/data-io/print.c	11 Nov 2006 00:13:14 -0000
@@ -96,11 +96,11 @@
     WRITE
   };
 
-static int internal_cmd_print (struct dataset *ds, 
+static int internal_cmd_print (struct lexer *, struct dataset *ds, 
 			       enum which_formats, bool eject);
 static trns_proc_func print_trns_proc;
 static trns_free_func print_trns_free;
-static bool parse_specs (struct pool *tmp_pool, struct print_trns *,
+static bool parse_specs (struct lexer *, struct pool *tmp_pool, struct print_trns *,
 			 struct dictionary *dict, enum which_formats);
 static void dump_table (struct print_trns *, const struct file_handle *);
 
@@ -108,28 +108,28 @@
 
 /* Parses PRINT command. */
 int
-cmd_print (struct dataset *ds)
+cmd_print (struct lexer *lexer, struct dataset *ds)
 {
-  return internal_cmd_print (ds, PRINT, false);
+  return internal_cmd_print (lexer, ds, PRINT, false);
 }
 
 /* Parses PRINT EJECT command. */
 int
-cmd_print_eject (struct dataset *ds)
+cmd_print_eject (struct lexer *lexer, struct dataset *ds)
 {
-  return internal_cmd_print (ds, PRINT, true);
+  return internal_cmd_print (lexer, ds, PRINT, true);
 }
 
 /* Parses WRITE command. */
 int
-cmd_write (struct dataset *ds)
+cmd_write (struct lexer *lexer, struct dataset *ds)
 {
-  return internal_cmd_print (ds, WRITE, false);
+  return internal_cmd_print (lexer, ds, WRITE, false);
 }
 
 /* Parses the output commands. */
 static int
-internal_cmd_print (struct dataset *ds, 
+internal_cmd_print (struct lexer *lexer, struct dataset *ds, 
 		    enum which_formats which_formats, bool eject)
 {
   bool print_table = 0;
@@ -149,33 +149,33 @@
   tmp_pool = pool_create_subpool (trns->pool);
 
   /* Parse the command options. */
-  while (token != '/' && token != '.')
+  while (lex_token (lexer) != '/' && lex_token (lexer) != '.')
     {
-      if (lex_match_id ("OUTFILE"))
+      if (lex_match_id (lexer, "OUTFILE"))
 	{
-	  lex_match ('=');
+	  lex_match (lexer, '=');
 
-	  fh = fh_parse (FH_REF_FILE);
+	  fh = fh_parse (lexer, FH_REF_FILE);
 	  if (fh == NULL)
 	    goto error;
 	}
-      else if (lex_match_id ("RECORDS"))
+      else if (lex_match_id (lexer, "RECORDS"))
 	{
-	  lex_match ('=');
-	  lex_match ('(');
-	  if (!lex_force_int ())
+	  lex_match (lexer, '=');
+	  lex_match (lexer, '(');
+	  if (!lex_force_int (lexer))
 	    goto error;
-	  trns->record_cnt = lex_integer ();
-	  lex_get ();
-	  lex_match (')');
+	  trns->record_cnt = lex_integer (lexer);
+	  lex_get (lexer);
+	  lex_match (lexer, ')');
 	}
-      else if (lex_match_id ("TABLE"))
+      else if (lex_match_id (lexer, "TABLE"))
 	print_table = true;
-      else if (lex_match_id ("NOTABLE"))
+      else if (lex_match_id (lexer, "NOTABLE"))
 	print_table = false;
       else
 	{
-	  lex_error (_("expecting a valid subcommand"));
+	  lex_error (lexer, _("expecting a valid subcommand"));
 	  goto error;
 	}
     }
@@ -185,10 +185,10 @@
   trns->include_prefix = which_formats == PRINT && fh != NULL;
 
   /* Parse variables and strings. */
-  if (!parse_specs (tmp_pool, trns, dataset_dict (ds), which_formats))
+  if (!parse_specs (lexer, tmp_pool, trns, dataset_dict (ds), which_formats))
     goto error;
 
-  if (lex_end_of_command () != CMD_SUCCESS)
+  if (lex_end_of_command (lexer) != CMD_SUCCESS)
     goto error;
 
   if (fh != NULL)
@@ -214,9 +214,9 @@
   return CMD_FAILURE;
 }
 
-static bool parse_string_argument (struct print_trns *,
+static bool parse_string_argument (struct lexer *, struct print_trns *,
                                    int record, int *column);
-static bool parse_variable_argument (const struct dictionary *, 
+static bool parse_variable_argument (struct lexer *, const struct dictionary *, 
 				     struct print_trns *,
                                      struct pool *tmp_pool,
                                      int *record, int *column,
@@ -226,35 +226,35 @@
    PRINT, PRINT EJECT, or WRITE command into the prt structure.
    Returns success. */
 static bool
-parse_specs (struct pool *tmp_pool, struct print_trns *trns,
+parse_specs (struct lexer *lexer, struct pool *tmp_pool, struct print_trns *trns,
 	     struct dictionary *dict, 
              enum which_formats which_formats)
 {
   int record = 0;
   int column = 1;
 
-  if (token == '.') 
+  if (lex_token (lexer) == '.') 
     {
       trns->record_cnt = 1;
       return true;
     }
 
-  while (token != '.')
+  while (lex_token (lexer) != '.')
     {
       bool ok;
 
-      if (!parse_record_placement (&record, &column))
+      if (!parse_record_placement (lexer, &record, &column))
         return false;
 
-      if (token == T_STRING)
-	ok = parse_string_argument (trns, record, &column);
+      if (lex_token (lexer) == T_STRING)
+	ok = parse_string_argument (lexer, trns, record, &column);
       else
-	ok = parse_variable_argument (dict, trns, tmp_pool, &record, &column,
+	ok = parse_variable_argument (lexer, dict, trns, tmp_pool, &record, &column,
                                       which_formats);
       if (!ok)
 	return 0;
 
-      lex_match (',');
+      lex_match (lexer, ',');
     }
 
   if (trns->record_cnt != 0 && trns->record_cnt != record)
@@ -268,23 +268,23 @@
 
 /* Parses a string argument to the PRINT commands.  Returns success. */
 static bool
-parse_string_argument (struct print_trns *trns, int record, int *column)
+parse_string_argument (struct lexer *lexer, struct print_trns *trns, int record, int *column)
 {
   struct prt_out_spec *spec = pool_alloc (trns->pool, sizeof *spec);
   spec->type = PRT_LITERAL;
   spec->record = record;
   spec->first_column = *column;
-  ds_init_string (&spec->string, &tokstr);
+  ds_init_string (&spec->string, lex_tokstr (lexer));
   ds_register_pool (&spec->string, trns->pool);
-  lex_get ();
+  lex_get (lexer);
 
   /* Parse the included column range. */
-  if (lex_is_number ())
+  if (lex_is_number (lexer))
     {
       int first_column, last_column;
       bool range_specified;
 
-      if (!parse_column_range (&first_column, &last_column, &range_specified)) 
+      if (!parse_column_range (lexer, &first_column, &last_column, &range_specified)) 
         return false; 
 
       spec->first_column = first_column;
@@ -301,7 +301,7 @@
    to fixed_parse_compatible() or fixed_parse_fortran() as appropriate.
    Returns success. */
 static bool
-parse_variable_argument (const struct dictionary *dict,
+parse_variable_argument (struct lexer *lexer, const struct dictionary *dict,
 			 struct print_trns *trns, struct pool *tmp_pool,
                          int *record, int *column,
                          enum which_formats which_formats)
@@ -312,12 +312,13 @@
   size_t format_cnt;
   bool add_space;
   
-  if (!parse_variables_pool (tmp_pool, dict, &vars, &var_cnt, PV_DUPLICATE))
+  if (!parse_variables_pool (lexer, tmp_pool, dict, 
+			     &vars, &var_cnt, PV_DUPLICATE))
     return false;
 
-  if (lex_is_number () || token == '(')
+  if (lex_is_number (lexer) || lex_token (lexer) == '(')
     {
-      if (!parse_var_placements (tmp_pool, var_cnt, false,
+      if (!parse_var_placements (lexer, tmp_pool, var_cnt, false,
                                  &formats, &format_cnt))
         return false;
       add_space = false;
@@ -326,7 +327,7 @@
     {
       size_t i;
 
-      lex_match ('*');
+      lex_match (lexer, '*');
       
       formats = pool_nmalloc (tmp_pool, var_cnt, sizeof *formats);
       format_cnt = var_cnt;
Index: src/language/dictionary/apply-dictionary.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/apply-dictionary.c,v
retrieving revision 1.9
diff -b -w -U3 -r1.9 apply-dictionary.c
--- src/language/dictionary/apply-dictionary.c	26 Oct 2006 06:16:36 -0000	1.9
+++ src/language/dictionary/apply-dictionary.c	11 Nov 2006 00:13:14 -0000
@@ -39,7 +39,7 @@
 
 /* Parses and executes APPLY DICTIONARY. */
 int
-cmd_apply_dictionary (struct dataset *ds)
+cmd_apply_dictionary (struct lexer *lexer, struct dataset *ds)
 {
   struct file_handle *handle;
   struct any_reader *reader;
@@ -49,9 +49,9 @@
 
   int i;
   
-  lex_match_id ("FROM");
-  lex_match ('=');
-  handle = fh_parse (FH_REF_FILE | FH_REF_SCRATCH);
+  lex_match_id (lexer, "FROM");
+  lex_match (lexer, '=');
+  handle = fh_parse (lexer, FH_REF_FILE | FH_REF_SCRATCH);
   if (!handle)
     return CMD_FAILURE;
 
@@ -136,5 +136,5 @@
   
   any_reader_close (reader);
 
-  return lex_end_of_command ();
+  return lex_end_of_command (lexer);
 }
Index: src/language/dictionary/formats.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/formats.c,v
retrieving revision 1.12
diff -b -w -U3 -r1.12 formats.c
--- src/language/dictionary/formats.c	3 Nov 2006 04:53:51 -0000	1.12
+++ src/language/dictionary/formats.c	11 Nov 2006 00:13:14 -0000
@@ -42,28 +42,28 @@
     FORMATS_WRITE = 002
   };
 
-static int internal_cmd_formats (struct dataset *ds, int);
+static int internal_cmd_formats (struct lexer *, struct dataset *ds, int);
 
 int
-cmd_print_formats (struct dataset *ds)
+cmd_print_formats (struct lexer *lexer, struct dataset *ds)
 {
-  return internal_cmd_formats (ds, FORMATS_PRINT);
+  return internal_cmd_formats (lexer, ds, FORMATS_PRINT);
 }
 
 int
-cmd_write_formats (struct dataset *ds)
+cmd_write_formats (struct lexer *lexer, struct dataset *ds)
 {
-  return internal_cmd_formats (ds, FORMATS_WRITE);
+  return internal_cmd_formats (lexer, ds, FORMATS_WRITE);
 }
 
 int
-cmd_formats (struct dataset *ds)
+cmd_formats (struct lexer *lexer, struct dataset *ds)
 {
-  return internal_cmd_formats (ds, FORMATS_PRINT | FORMATS_WRITE);
+  return internal_cmd_formats (lexer, ds, FORMATS_PRINT | FORMATS_WRITE);
 }
 
 static int
-internal_cmd_formats (struct dataset *ds, int which)
+internal_cmd_formats (struct lexer *lexer, struct dataset *ds, int which)
 {
   /* Variables. */
   struct variable **v;
@@ -80,24 +80,24 @@
 
   for (;;)
     {
-      if (token == '.')
+      if (lex_token (lexer) == '.')
 	break;
 
-      if (!parse_variables (dataset_dict (ds), &v, &cv, PV_NUMERIC))
+      if (!parse_variables (lexer, dataset_dict (ds), &v, &cv, PV_NUMERIC))
 	return CMD_FAILURE;
       type = v[0]->type;
 
-      if (!lex_match ('('))
+      if (!lex_match (lexer, '('))
 	{
 	  msg (SE, _("`(' expected after variable list."));
 	  goto fail;
 	}
-      if (!parse_format_specifier (&f)
+      if (!parse_format_specifier (lexer, &f)
           || !fmt_check_output (&f)
           || !fmt_check_type_compat (&f, NUMERIC))
 	goto fail;
 
-      if (!lex_match (')'))
+      if (!lex_match (lexer, ')'))
 	{
 	  msg (SE, _("`)' expected after output format."));
 	  goto fail;
